extern string  sComment1		= "> Hour-Hour Range Scan";
extern int     iOpenHour		= 6;
extern string  sComment2		= "> Corrects Calculations if your chart skips a 1 hr bar over sundays";
extern bool    sundaybarcorrect	= true;

int start()
  {
                                                            
int b, scannedhour, scannedbarday;
datetime bartime ;
double dibsclose, dibsopen, prevdayrange[5];       //  prevdayrange Array Categorys ( 0  EURUSD, 1 GBPUSD, 2 USDCHF, 3 USDJPY, 4 AUDUSD )

//----------------------------------------------------------------------------------------------
//        EURUSD PREV DAY RANGE CALC

for(b=0; b<=24; b++)                                                // scans the last 24 bars on eurusd
   {
      bartime = iTime("EURUSD", 60, b);                             // checks the open time of each bar
      scannedhour = TimeHour(bartime);                              // extracts the hour of that bar
      scannedbarday = TimeDayOfWeek(bartime);
      
      if ( scannedhour == iOpenHour )                               // Check to see if scanned hour = Dibs hour
         {
            dibsclose    = iOpen("EURUSD", 60, b);                  // checks the open time of bar -24
            if ( scannedbarday == 1 && sundaybarcorrect==1)         // If a monday bar is detected
               {
                 dibsopen     = iOpen("EURUSD", 60, b+23);          // -1 to account for missing sunday bar
               }
            else { dibsopen     = iOpen("EURUSD", 60, b+24);}       // Get the value of the bar 24 bars before the Dibs bar (Open of 6gmt day)  
            prevdayrange[0] = (dibsclose-dibsopen);                 // Calculate the range of the Dibs day
         }                                                          // End of if statement
    }                                                               // End of for statement
    

//----------------------------------------------------------------------------------------------
//        GBPUSD PREV DAY RANGE CALC

for(b=0; b<=24; b++)                                                // scans the last 24 bars on eurusd
   {
      bartime = iTime("GBPUSD", 60, b);                             // checks the open time of each bar
      scannedhour = TimeHour(bartime);                              // extracts the hour of that bar
      scannedbarday = TimeDayOfWeek(bartime);
      
      if ( scannedhour == iOpenHour )                               // Check to see if scanned hour = Dibs hour
         {
            dibsclose    = iOpen("GBPUSD", 60, b);                  // Get the open value of that bar (Close of 6gmt day) 
            if ( scannedbarday == 1 && sundaybarcorrect==1)         // If a monday bar is detected
               {
                 dibsopen     = iOpen("GBPUSD", 60, b+23);          // -1 to account for missing sunday bar
               }
            else { dibsopen     = iOpen("GBPUSD", 60, b+24);}       // Get the value of the bar 24 bars before the Dibs bar (Open of 6gmt day)
            prevdayrange[1] = (dibsclose-dibsopen);                 // Calculate the range of the Dibs day
         }                                                          // End of if statement
    }                                                               // End of for statement



//----------------------------------------------------------------------------------------------
//        USDCHF PREV DAY RANGE CALC

for(b=0; b<=24; b++)                                                // scans the last 24 bars on eurusd
   {  
      bartime = iTime("EURUSD", 60, b);                             // checks the open time of each bar
      scannedhour = TimeHour(bartime);                              // extracts the hour of that bar
      scannedbarday = TimeDayOfWeek(bartime);
      
      if ( scannedhour == iOpenHour )                               // Check to see if scanned hour = Dibs hour
         {
            dibsclose    = iOpen("USDCHF", 60, b);                  // Get the open value of that bar (Close of 6gmt day) 
            if ( scannedbarday == 1 && sundaybarcorrect==1)         // If a monday bar is detected
               {
                 dibsopen     = iOpen("USDCHF", 60, b+23);          // -1 to account for missing sunday bar
               }
            else { dibsopen     = iOpen("USDCHF", 60, b+24);}       // Get the value of the bar 24 bars before the Dibs bar (Open of 6gmt day)
            prevdayrange[2] = (dibsclose-dibsopen);                 // Calculate the range of the Dibs day
         }                                                          // End of if statement
    }                                                               // End of for statement



//----------------------------------------------------------------------------------------------
//        USDJPY PREV DAY RANGE CALC

for(b=0; b<=24; b++)                                                // scans the last 24 bars on eurusd
   {
      bartime = iTime("USDJPY", 60, b);                             // checks the open time of each bar
      scannedhour = TimeHour(bartime);
      scannedbarday = TimeDayOfWeek(bartime);                       // extracts the hour of that bar
    
      if ( scannedhour == iOpenHour )                               // Check to see if scanned hour = Dibs hour
         {
            dibsclose    = iOpen("USDJPY", 60, b);                  // Get the open value of that bar (Close of 6gmt day) 
            if ( scannedbarday == 1 && sundaybarcorrect==1)         // If a monday bar is detected
               {
                 dibsopen     = iOpen("USDJPY", 60, b+23);          // -1 to account for missing sunday bar
               }
            else { dibsopen     = iOpen("USDJPY", 60, b+24);}       // Get the value of the bar 24 bars before the Dibs bar (Open of 6gmt day)
            prevdayrange[3] = ((dibsclose-dibsopen)/100);                 // Calculate the range of the Dibs day
         }                                                          // End of if statement
    }                                                               // End of for statement
    
    
//----------------------------------------------------------------------------------------------
//        AUDUSD PREV DAY RANGE CALC

for(b=0; b<=24; b++)                                                // scans the last 24 bars on eurusd
   {
      bartime = iTime("AUDUSD", 60, b);                             // checks the open time of each bar
      scannedhour = TimeHour(bartime);                              // extracts the hour of that bar
      scannedbarday = TimeDayOfWeek(bartime);
      
      if ( scannedhour == iOpenHour )                               // Check to see if scanned hour = Dibs hour
         {
            dibsclose    = iOpen("AUDUSD", 60, b);                  // checks the open time of bar -24
            if ( scannedbarday == 1 && sundaybarcorrect==1)         // If a monday bar is detected
               {
                 dibsopen     = iOpen("AUDUSD", 60, b+23);          // -1 to account for missing sunday bar
               }
            else { dibsopen     = iOpen("AUDUSD", 60, b+24);}       // Get the value of the bar 24 bars before the Dibs bar (Open of 6gmt day)  
            prevdayrange[4] = (dibsclose-dibsopen);                 // Calculate the range of the Dibs day
         }                                                          // End of if statement
    }                                                               // End of for statement
    
//----------------------------------------------------------------------------------------------

int strongrange = ArrayMaximum(prevdayrange,WHOLE_ARRAY,0);       //find the pair with the stronget range
int weakrange = ArrayMinimum(prevdayrange,WHOLE_ARRAY,0);         //find the pair with the weakest range
string strongmarket, weakmarket, hothand;
string EURUSDR=DoubleToStr(prevdayrange[0]*10000, 2);             //Conver double variables to strings for comment function
string GBPUSDR=DoubleToStr(prevdayrange[1]*10000, 2);
string USDCHFR=DoubleToStr(prevdayrange[2]*10000, 2);
string USDJPYR=DoubleToStr(prevdayrange[3]*10000, 2);
string AUDUSDR=DoubleToStr(prevdayrange[4]*10000, 2);
 





if (prevdayrange[strongrange] <0)strongmarket="No bullish Markets";  //If the maxium value is a negative number no bull markets
else
   {
      if (strongrange==0) strongmarket="EURUSD";                     //Display strongest market
      if (strongrange==1) strongmarket="GBPUSD";
      if (strongrange==2) strongmarket="USDCHF";
      if (strongrange==3) strongmarket="USDJPY";
      if (strongrange==4) strongmarket="AUDUSD";
   }

if (prevdayrange[weakrange] >0)  weakmarket="No bearish Markets";                          // If the weakest number is positive no bear markets
          
else
   {
      if (weakrange==0) weakmarket="EURUSD";
      if (weakrange==1) weakmarket="GBPUSD";                         //Display weakest market
      if (weakrange==2) weakmarket="USDCHF";
      if (weakrange==3) weakmarket="USDJPY";
      if (weakrange==4) weakmarket="AUDUSD";
   }
 
 if((prevdayrange[weakrange]*(-1))> prevdayrange[strongrange])
   {
      if (weakrange==0) hothand="EURUSD";
      if (weakrange==1) hothand="GBPUSD";                         //Get hothand value if bearish range > bullish
      if (weakrange==2) hothand="USDCHF";
      if (weakrange==3) hothand="USDJPY";
      if (weakrange==4) hothand="AUDUSD";
   }
 else 
   {  
      if (strongrange==0) hothand="EURUSD";                     //Get hothand value if bullish range > bearish range
      if (strongrange==1) hothand="GBPUSD";
      if (strongrange==2) hothand="USDCHF";
      if (strongrange==3) hothand="USDJPY";
      if (strongrange==4) hothand="AUDUSD";
   }  
      



Comment("EURUSD RANGE=", EURUSDR,"PIPS\n",         //Display Ranges of each pair
        "GBPUSD RANGE=", GBPUSDR,"PIPS\n",
        "USDCHF RANGE=", USDCHFR,"PIPS\n",
        "USDJPY RANGE=", USDJPYR,"PIPS\n",
        "AUDUSD RANGE=", AUDUSDR,"PIPS\n",
        "HOT HAND BULLISH=", strongmarket,"\n",
        "HOT HAND BEARISH=", weakmarket,"\n",
        "HOTHAND=", hothand);      
        


   return(0);
  }
//+------------------------------------------------------------------+